# 그누보드 도커로 실행하기

> LEMP(Nginx, Mariadb, php 8.1) 환경에서 그누보드 설치하기 과정입니다.

## 그누보드 설정

1. gnuboard.v5.5.8.3.zip 파일의 압축을 풉니다.

2. gnuboard5-master 디렉토리 이름을 적당히 변경합니다. (예: culture.local.kr)

3. ./culture.local.kr/data 디렉토리를 생성하고 권한을 변경합니다.
    ```
      $ cd ./sites/culture.local.kr
      $ mkdir data
      $ chmod 707 data
      $ cd -
    ```

4. culture.local.kr 도메인을 hosts 파일에 등록합니다.
    ```
      $ sudo vi /etc/hosts
    ```

    파일에 내용 추가
    ```
      127.0.0.1           culture.local.kr
    ```

5. hosts파일을 리프레시 합니다.
    ```
      $ dscacheutil -flushcache
    ```

## 도커 설정

1. 환경파일을 생성합니다.
    ```
      cp env.sample .env
    ```
    변수 값을 여러분이 원하는 값대로 변경합니다.
    ```
      MYSQL_PORT=3306
      MYSQL_DATABASE=gnu
      MYSQL_USER=gnu
      MYSQL_PASSWORD=gnu2023
      MYSQL_ROOT_PASSWORD=gnu2023
    ```
2. 도커를 실행합니다.
    ```
    docker-compose -f ./docker-lemp-gnuboard/docker-compose.yml up
    ```


## 실행 확인

1. 브라우저를 열어 접속을 해 봅니다.
    ```
      http://culture.local.kr
    ```

2. MySQL 정보를 아래와 같이 입력합니다.
    ```
      Host: db
      User: .env에 설정한 MYSQL_USER
      Password: .evn에 설정한 MYSQL_PASSWORD
      DB: .evn에 설정한 MYSQL_DATABASE
    ```
    나머지는 여러분이 원하는 값을 입력합니다.

# 참고자료
## 최신 버전의 그누보드를 다운 받으려면

```
cd sites
wget https://github.com/gnuboard/gnuboard5/archive/master.zip
unzip master.zip
```

